//
// Copyright (C) 2001,2002,2003,2004 Jorge Daza Garcia-Blanes
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
// USA
//
// $Id: /drqueue/remote/tags/0.64.3/master.h 1806 2007-02-19T06:37:39.067051Z jorge  $
//

#ifndef _MASTER_H_
#define _MASTER_H_

#include "database.h"
#include "constants.h"
#include <stdint.h>

#include <stdint.h>

#define KEY_MASTER "master" /* Key for shared memory and semaphores */

extern int phantom[2];

void master_get_options (int *argc,char ***argv, int *force);
void usage (void);

int64_t get_shared_memory (int force);
int64_t get_semaphores (int force);
void *attach_shared_memory (int64_t shmid);

void set_signal_handlers (void);
void set_signal_handlers_child_conn_handler (void);
void set_signal_handlers_child_cchecks (void);

void clean_out (int signal);
void sigalarm_handler (int signal);
void sigpipe_handler (int signal);
void sigsegv_handler (int signal);
void set_alarm (void);

void master_consistency_checks (struct database *wdb); /* Main consistency checks function */
void check_lastconn_times (struct database *wdb);


#endif /* _MASTER_H_ */
